package bin;

import kernel.log.Log;
import lib.ui.elements.TextElement;
import lib.Pos;
import lib.ui.elements.UIElement;
import lib.ui.elements.LayerdRootElement;
import kernel.ui.WindowContext;
import kernel.ps.ProcessHandle;
import kernel.ps.Process;

@:build(macros.Binstore.includeBin("HelloWorld-GUI", ["hello-gui"]))
class HelloWorldGUI implements Process {
	private var handle:ProcessHandle;
	private var ctx:WindowContext;
	private var requestRender:Void->Void;
	private var root:LayerdRootElement;

	public function new() {}

	public function run(handle:ProcessHandle) {
		this.handle = handle;

		var stateless = handle.createStatelessWindowContext();
		this.ctx = stateless.ctx;
		this.requestRender = stateless.requestRender;

		stateless.setRenderFunc(this.render);

		this.root = new LayerdRootElement();

		this.ctx.delegateEvents(this.root);

		this.requestRender();
	}

	private function render() {
		var children:Array<{element:UIElement, offset:Pos}> = [
			{
				element: new TextElement("Hello World", {
					uiEvents: {
						onClick: () -> {
							Log.debug("Hello World");
						}
					}
				}),
				offset: new Pos({x: 0, y: 0})
			},
			{
				element: new TextElement("Holla Mundo", {
					uiEvents: {
						onClick: () -> {
							Log.debug("Holla Mundo");
						}
					}
				}),
				offset: new Pos({x: 0, y: 1})
			},
			{
				element: new TextElement("Ayyy", {
					uiEvents: {
						onClick: () -> {
							Log.debug("Ayy");
						}
					}
				}),
				offset: new Pos({x: 4, y: 1})
			}
		];

		this.root.setChildren(children);
		this.root.render(ctx.getSize()).renderToContext(ctx);
	}
}
