package lib.ui.elements;

class LayerdRootElement implements UIElement {
	private var children:Array<{element:UIElement, offset:Pos}>;
	private final eventManager:UIEventManager = new UIEventManager();

	public function new(?children:Array<{element:UIElement, offset:Pos}>) {
		this.children = children == null ? [] : children;
	}

	public function setChildren(children:Array<{element:UIElement, offset:Pos}>) {
		this.children = children;
	}

	public function getEventHandlers():UIEvents {
		return eventManager.getEventHandlers();
	}

	public function render(bounds:Pos):Canvas {
		this.eventManager.clearMap();

		var stack = new CanvasStack();

		for (child in this.children) {
			var canvas = child.element.render(bounds);
			var bound = canvas.getBounds();
			bound.offset(child.offset);
			eventManager.addMapElement(child.element, bound);
			stack.addLayer(canvas, child.offset);
		}

		return stack.compress();
	}
}
